﻿' Константы реестра
Const HKEY_LOCAL_MACHINE            = &H80000002
Const HKEY_CURRENT_USER             = &H80000001
' Константы служб
Const ADS_SERVICE_STOPPED			= &H1
Const ADS_SERVICE_START_PENDING		= &H2
Const ADS_SERVICE_STOP_PENDING		= &H3
Const ADS_SERVICE_RUNNING			= &H4
Const ADS_SERVICE_CONTINUE_PENDING	= &H5
Const ADS_SERVICE_PAUSE_PENDING		= &H6
Const ADS_SERVICE_PAUSED 			= &H7
Const ADS_SERVICE_ERROR				= &H8
' Константы листов безопасности
Const ADS_PATH_FILE						= 1
Const ADS_PATH_FILESHARE				= 2
Const ADS_PATH_REGISTRY					= 3
Const ADS_SD_FORMAT_IID					= 1
Const ADS_SD_FORMAT_RAW					= 2
Const ADS_SD_FORMAT_HEXSTRING			= 3
' Константы учетных записей
Const SEC_IN_DAY = 86400
Const ADS_UF_DONT_EXPIRE_PASSWD = &h10000


' Глобальные переменные
Dim gWorkDirectory
Dim gDomainRoot
Dim gDomainName
Dim gDomainControllers
Dim gAdminShares
Dim gAdminAccounts
Dim gComputerDefaultName
Dim gUserDefaultName
Dim gWindowsFolder

' Процедура инициализации окна формы
Sub WindowOnLoad
    Dim CurrentResolution
    Set oShell = CreateObject("Wscript.Shell")
    ' Размер окна
    iWidth = 1000
    iHeight = 410
    ' Получение текущего разрешения экрана
    CurrentResolution = GetDisplayResolution()
    ' Изменение размера окна и его центрирование
    iLeft = (Split(CurrentResolution,";")(0) - iWidth) / 2
    iTop = (Split(CurrentResolution,";")(1) - iHeight) / 2
    Self.Focus()
    Self.resizeTo iWidth, iHeight
    Self.moveTo iLeft, iTop
    ' Вывод версии приложения на форму
    Version_Div.InnerHTML = "Версия: " & oHTA.Version
    ' Получение текущей директории
    gWorkDirectory = oShell.CurrentDirectory
    ' Чтение файла конфигурации
    gDomainRoot = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "DomainRoot")
    gDomainName = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "DomainName")
    gDomainControllers = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "DomainControllers")
    gAdminShares = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "AdminShares")
    gAdminAccounts = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "AdminAccounts")
    gComputerDefaultName = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "ComputerDefaultName")
    gUserDefaultName = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "UserDefaultName")
    gWindowsFolder = ReadIni(gWorkDirectory & "\MyHTA_files\MyHTA.ini", "Configuration", "WindowsFolder")
    ' Заполнение объектов формы
    Computer_Input.value = gComputerDefaultName
    User_Input.value = gUserDefaultName
	For Each sDomainController In Split(gDomainControllers,";")
        set oOption = document.createElement("OPTION")
        DC_Select.options.add(oOption)
        oOption.innerText = sDomainController
        oOption.value = sDomainController
	Next
End Sub

' Процедура выбора и выполнения задач
Sub ExecuteTask(sName)
    On Error Resume Next
    Action_Div.InnerHTML = "Пожалуйста подождите, выполняется команда"
    Set oShell = CreateObject("Wscript.Shell")
    Call ccSleep(1)
    ' Определение выбранной задачи
    SelectedTask = ""
    For Each CurrentTask in Task_Input
        If CurrentTask.Checked = True Then
            SelectedTask = CurrentTask.Value
        End If
    Next
    ' Выполнение выбранной задачи
    Select Case SelectedTask
        ' Подключение к компьютеру
        Case "ConnectToComputer"
            If PingComputer(Computer_Input.value) = True Then
                CommandLine = "%COMSPEC% /c """ & gWorkDirectory & "\MyHTA_files\GetScreen.exe"" -s " & Computer_Input.value
                oShell.Run CommandLine,0,0
                Action_Div.InnerHTML = "Программа подключения к " & Computer_Input.value & " запущена"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Открытие диска С: компьютера
        Case "OpenSystemDisk"
            If PingComputer(Computer_Input.value) = True Then
                CommandLine = "Explorer \\" & Computer_Input.value & "\C$"
                oShell.Run CommandLine,1,0
                Action_Div.InnerHTML = "Проводник с системным диском компьютера " & Computer_Input.value & " открыт"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Перезагрузка компьютера
        Case "RestartComputer"
            If PingComputer(Computer_Input.value) = True Then
                iAnswer = MsgBox("Вы уверены, что нужно перезагрузить компьютер " & Computer_Input.value & "?", vbYesNo, "Подтверждение")
                If iAnswer = vbYes then
                    CommandLine = """" & gWorkDirectory & "\MyHTA_files\shutdown.exe"" -r -f -m \\" & Computer_Input.value & " -t 0 -c ""Administrative restarting"""
                    oShell.Run CommandLine,1,0
                    Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " отправлен на перезагрузку"
                Else
				    Action_Div.InnerHTML = "Перезагрузка компьютера " & Computer_Input.value & " отменена"
                End if
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Корректировка кодовой страницы
        Case "DoCorrectingCodepage"
            If PingComputer(Computer_Input.value) = True Then
			    Set oReg=GetObject("winmgmts:\\" & Computer_Input.value & "\root\default:StdRegProv")
			    sKeyPath = "SYSTEM\CurrentControlSet\Control\Nls\CodePage"
			    sValueName = "1250"
			    Value = "c_1251.nls"
			    oReg.SetStringValue HKEY_LOCAL_MACHINE, sKeyPath, sValueName,Value
			    sValueName = "1252"
			    Value = "c_1251.nls"
			    oReg.SetStringValue HKEY_LOCAL_MACHINE, sKeyPath, sValueName,Value
                Action_Div.InnerHTML = "Кодовая страница на компьютере " & Computer_Input.value & " исправлена, компьютер нужно перезагрузить"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Отмена корректировки кодовой страницы
        Case "UndoCorrectingCodepage"
            If PingComputer(Computer_Input.value) = True Then
			    Set oReg=GetObject("winmgmts:\\" & Computer_Input.value & "\root\default:StdRegProv")
			    sKeyPath = "SYSTEM\CurrentControlSet\Control\Nls\CodePage"
			    sValueName = "1250"
			    Value = "c_1250.nls"
			    oReg.SetStringValue HKEY_LOCAL_MACHINE, sKeyPath, sValueName,Value
			    sValueName = "1252"
			    Value = "c_1252.nls"
			    oReg.SetStringValue HKEY_LOCAL_MACHINE, sKeyPath, sValueName,Value
                Action_Div.InnerHTML = "Кодовая страница на компьютере " & Computer_Input.value & " исправлена, компьютер нужно перезагрузить"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Презапуск службы WMI
        Case "RestartWMI"
            If PingComputer(Computer_Input.value) = True Then
			    Set oWMIService = GetObject("winmgmts:\\" & Computer_Input.value & "\root\cimv2")
			    Set colServiceList = oWMIService.ExecQuery("Associators of {Win32_Service.Name='winmgmt'} WHERE AssocClass=Win32_DependentService Role=Antecedent" )
			    For Each oService In colServiceList
				    oService.StopService()
			    Next
			    ccSleep(5)
			    Set colServiceList = oWMIService.ExecQuery ("SELECT * FROM Win32_Service WHERE Name='winmgmt'")
			    For Each oService In colServiceList
				    errReturn = oService.StopService()
			    Next
			    ccSleep(5)
			    Set oWMIService = GetObject("winmgmts:\\" & Computer_Input.value & "\root\cimv2")
			    Set colServiceList = oWMIService.ExecQuery ("Select * from Win32_Service where Name='winmgmt'")
			    For Each oService In colServiceList
				    errReturn = oService.StartService()
			    Next
			    ccSleep(5)
			    Set colServiceList = oWMIService.ExecQuery("Associators of {Win32_Service.Name='winmgmt'} WHERE AssocClass=Win32_DependentService Role=Dependent" )
			    For Each oService In colServiceList
				    oService.StartService()
			    Next
                Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " перезапущена"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Удаление репозитория службы WMI
        Case "CorrectWMI"
          If PingComputer(Computer_Input.value) = True Then
            Set oFSO = CreateObject ("Scripting.FileSystemObject")
            If oFSO.FolderExists ("\\" & Computer_Input.value & "\C$\" & gWindowsFolder & "\system32\wbem\Repository") Then
				    Set oFolder = oFSO.GetFolder("\\" & Computer_Input.value & "\C$\WINXP\system32\wbem\Repository")
				    Set	oWMIService = getObject("WinNT://" & Computer_Input.value & "/winmgmt")
				    On Error Resume Next
				    Set oSharedAccessService = getObject("WinNT://" & Computer_Input.value & "/SharedAccess")
				    Set oSMSAgentService = getObject("WinNT://" & Computer_Input.value & "/CcmExec")
				    Set oSecurityAccessService = getObject("WinNT://" & Computer_Input.value & "/wscsvc")
				    If oWMIService.Status = ADS_SERVICE_RUNNING	Then
					    If oSharedAccessService.Status = ADS_SERVICE_RUNNING Then oSharedAccessService.Stop
					    If oSMSAgentService.Status = ADS_SERVICE_RUNNING Then oSMSAgentService.Stop
					    If oSecurityAccessService.Status = ADS_SERVICE_RUNNING Then oSecurityAccessService.Stop
					    iCounter = 0
					    ccSleep(5)
					    Do
						    If iCounter = 10 then
							    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " не может быть починена в автоматическом режиме"
							    Exit Sub
						    End If
						    iCounter = iCounter + 1
						    ccSleep(1)
					    Loop Until (oSharedAccessService.Status = ADS_SERVICE_STOPPED and _
						    oSMSAgentService.Status = ADS_SERVICE_STOPPED and _
						    oSecurityAccessService.Status = ADS_SERVICE_STOPPED)
					    oWMIService.Stop
					    iCounter = 0
					    ccSleep(5)
					    Do
						    If iCounter = 10 then
							    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " не может быть починена в автоматическом режиме"
							    Exit Sub
						    End if
						    iCounter = iCounter + 1
						    ccSleep(1)
					    Loop Until (oWMIService.Status = ADS_SERVICE_STOPPED)
					    oFolder.Delete
					    oWMIService.Start
					    iCounter = 0
					    ccSleep(5)
					    Do
						    If iCounter = 10 then
							    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " не может быть починена в автоматическом режиме"
							    Exit Sub
						    End If
						    iCounter = iCounter + 1
						    ccSleep(1)
					    Loop Until (oWMIService.Status = ADS_SERVICE_RUNNING)
					    oSharedAccessService.Start
					    oSMSAgentService.Start
					    oSecurityAccessService.Start
					    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " починена"
				    else
					    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " не может быть починена в автоматическом режиме"
				    end if
			    else
				    Action_Div.InnerHTML = "Служба WMI на компьютере " & Computer_Input.value & " не может быть починена в автоматическом режиме"
			    end if
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Отключение сетевых ресурсов и запрещение создания новых
        Case "RestrictSharedFolders"
            If PingComputer(Computer_Input.value) = True Then
        		Call UnShareFolders (Computer_Input.value)
		        Call RemoveUsersFromSecurity ("\\" & Computer_Input.value & "\C$\" & gWindowsFolder & "\system32\ntshrui.dll")
		        Call RemoveUsersFromSecurity ("\\" & Computer_Input.value & "\C$\" & gWindowsFolder & "\system32\compmgmt.msc")
		        Action_Div.InnerHTML = "Сетевые папки компьютера " & Computer_Input.value & " закрыты, пользователям этого компьютера запрещено создавать новые сетевые папки"
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Показать текущего пользователя компьютера
        Case "ShowCurrentUser"
            If PingComputer(Computer_Input.value) = True Then
                Set oWMIService = GetObject("winmgmts:\\" & Computer_Input.value & "\root\cimv2")
                Set oComputerSystem = oWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem")
			    For Each oObject In oComputerSystem
                    If oObject.UserName <> "null" Then
    		            Action_Div.InnerHTML = "На компьютере " & Computer_Input.value & " сейчас работает " & oObject.UserName & " - " & GetUserName(Mid(oObject.UserName, Len(gDomainName) + 2))
                    Else
                        Action_Div.InnerHTML = "Пользователь компьютера " & Computer_Input.value & " не определен"
				    End If
                Next
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Показать время загрузки компьютера
        Case "ShowLastBootUpTime"
            If PingComputer(Computer_Input.value) = True Then
                Set oWMIService = GetObject("winmgmts:\\" & Computer_Input.value & "\root\cimv2")
                Set oComputerSystem = oWMIService.ExecQuery("SELECT * FROM Win32_OperatingSystem")
                For Each oObject In oComputerSystem
                    sLastBootUpTime = Mid(oObject.LastBootUpTime,9,2) & ":" & Mid(oObject.LastBootUpTime,11,2) & "    " & Mid(oObject.LastBootUpTime,7,2) & "." & Mid(oObject.LastBootUpTime,5,2) & "." & Left(oObject.LastBootUpTime,4)
                    Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " был включен в " & sLastBootUpTime
                Next
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        ' Показать установки системы компьютера
        Case "ShowInstallDate"
            If PingComputer(Computer_Input.value) = True Then
                Set oWMIService = GetObject("winmgmts:\\" & Computer_Input.value & "\root\cimv2")
                Set oComputerSystem = oWMIService.ExecQuery("SELECT * FROM Win32_OperatingSystem")
                For Each oObject In oComputerSystem
                    sInstallationDate = Mid(oObject.InstallDate,9,2) & ":" & Mid(oObject.InstallDate,11,2) & "    " & Mid(oObject.InstallDate,7,2) & "." & Mid(oObject.InstallDate,5,2) & "." & Left(oObject.InstallDate,4)
                    Action_Div.InnerHTML = "Система компьютера " & Computer_Input.value & " была установлена в " & sInstallationDate
                Next
            Else
                Action_Div.InnerHTML = "Компьютер " & Computer_Input.value & " выключен или не в сети"
            End If
        Case "CheckUserStatus"
             Action_Div.InnerHTML = "Пользователь " & CheckUserStatus(User_Input.value, DC_Select.value)
        Case "UnlockUser"
            Action_Div.InnerHTML = "Пользователь " & UnlockUser(User_Input.value, DC_Select.value)
        Case "CheckWhenUserPasswordExpires"
            Action_Div.InnerHTML = CheckWhenPasswordExpires(User_Input.value, DC_Select.value)
        Case "ResetUserPassword"
            Action_Div.InnerHTML = ResetUserPassword(User_Input.value, DC_Select.value, LCase(User_Input.value))
        Case Else
            Action_Div.InnerHTML = "Вы не выбрали действие"
    End Select
    If Err.Number <> 0 Then
        Action_Div.InnerHTML = "Ошибка выполнения команды - возможно, у вас не хватает прав"
        Err.Number = 0
    End If
End Sub

' Функция чтения файла
Function ReadFile(sFileName)
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    Set oInFile = oFSO.OpenTextFile(sFileName, 1, False, 0)
    sFileContent = oInFile.ReadAll
    oInFile.Close
    ReadFile = sFileContent
End Function

' Функция проверки наличия файла
Function CheckFile(sFilePath)
    Set oFSO = CreateObject("Scripting.FileSystemObject")
    If oFSO.FileExists(sFilePath) Then
        CheckFile = True
    Else
        CheckFile = false
    End If
End Function

' Функция получения разрешения экрана
Function GetDisplayResolution()
    Set oWMIService = GetObject("winmgmts:\\.\root\cimv2")
    Set colItems = oWMIService.ExecQuery("Select * From Win32_DesktopMonitor")
    For Each oItem In colItems
        iHorizontal = oItem.ScreenWidth
        iVertical = oItem.ScreenHeight
    Exit For
    Next
    GetDisplayResolution = iHorizontal & ";" & iVertical
End Function

' Функция проверки связи с компьютером
Function PingComputer(sComputer)
    Set oPing = GetObject("winmgmts:{impersonationLevel=impersonate}").ExecQuery("SELECT * from Win32_PingStatus where address = '" & sComputer & "'")
    For Each oStatus In oPing
        If IsNull(oStatus.StatusCode) Or oStatus.StatusCode <> 0 Then 
            PingComputer = False
        Else
            PingComputer = True
        End If
    Next
End Function

' Процедура задержки выполнения программы
Sub ccSleep(seconds)
    Set oShell = CreateObject("Wscript.Shell")
    sCommand = "%COMSPEC% /c ping -n " & 1 + seconds & " 127.0.0.1>nul"
    oShell.Run sCommand,0,1
End Sub

' Функция чления файла конфигурации
Function ReadIni(sFileName, sSection, sKey)
	Dim aStrings()
	Set oFSO = CreateObject("Scripting.FileSystemObject")
	Set oInFile = oFSO.OpenTextFile(sFileName, 1, False, 0)
	Do While oInFile.AtEndOfStream <> True
		ReDim Preserve aStrings(iCounter)
		aStrings(iCounter) = oInFile.ReadLine
		iCounter = iCounter + 1
	Loop
	oInFile.Close
	iStartSection = UBound(aStrings)
	iEndSection = UBound(aStrings)
	For iCounter = 0 To UBound(aStrings)
		If InStr(1, aStrings(iCounter), "[" & sSection & "]", vbTextCompare) Then
			iStartSection = iCounter + 1
		End If
		If iCounter >= iStartSection Then
			If InStr(1, aStrings(iCounter), "[", vbTextCompare) Then
				iEndSection = iCounter - 1
				Exit For
			End If
		End If
	Next
	For iCounter = iStartSection To iEndSection
		If InStr(1, aStrings(iCounter), sKey & "=", vbTextCompare) Or InStr(1, aStrings(iCounter), sKey & " =", vbTextCompare) Then
			ReadIni = Trim(Mid(aStrings(iCounter), InStr(1, aStrings(iCounter), "=", vbTextCompare) + 1, Len(aStrings(iCounter)) - (InStr(1, aStrings(iCounter), "=", vbTextCompare))))
			Exit For
		Else
			ReadIni = ""
		End If
	Next
End Function

' Процедура закрытия сетевых ресурсов компьютера
Sub UnShareFolders (Computer)
	Set objWMIService = GetObject("winmgmts:\\" & Computer & "\root\cimv2")
	Set objNewShare = objWMIService.Get("Win32_Share")
	Set colShares = objWMIService.ExecQuery ("SELECT * FROM Win32_Share WHERE Type = 0")
	For Each oShare In colShares
		iFlag = 0
		For Each sShare In Split(gAdminShares, ";")
			If (Trim(LCase(oShare.Name)) = Trim(LCase(sShare))) Then
				iFlag = iFlag + 1
			End If
		Next
		If iFlag = 0 Then oShare.Delete
	Next
End sub

' Процедура изменения списка безопасности файла
Sub RemoveUsersFromSecurity (FileName)
    Set oADsSecurityUtility = CreateObject("ADsSecurityUtility")
    Set oSD = oADsSecurityUtility.GetSecurityDescriptor(FileName, ADS_PATH_FILE, ADS_SD_FORMAT_IID)
    Set oDACL = oSD.DiscretionaryAcl
    For each OACE in oDACL
        iFlag = 0
        For Each sAccount In Split(gAdminAccounts, ";")
            If (Trim(LCase(oACE.Trustee)) = Trim(LCase(sAccount))) Then iFlag = iFlag + 1
        Next
        If iFlag = 0 then oDacl.RemoveAce (oACE)
    Next
    oSD.DiscretionaryAcl = oDacl
    oADsSecurityUtility.SetSecurityDescriptor FileName, ADS_PATH_FILE, oSD, ADS_SD_FORMAT_IID
End Sub

' Получение имени пользователя по его учетной записи
Function GetUserName(UserAccount)
    On Error Resume Next
    Set oConAD = CreateObject("ADODB.Connection")
    Set oCom = CreateObject("ADODB.Command")
    oConAD.Provider = "ADsDSOObject"
    oConAD.Open
    oCom.ActiveConnection = oConAD
    oCom.CommandText = "<LDAP://" & gDomainRoot & ">;(&(objectClass=user)(samaccountname=" & UserAccount &"));samaccountname,name;SubTree"
    Set aResult = oCom.Execute()
    sUserName = aResult("name")
    If Err.Number = 0 Then
        GetUserName = sUserName
    Else
        GetUserName = "не найден"
        Err.Number = 0
    End If
End Function

' Проверка состояния учетной записи пользователя
Function CheckUserStatus(UserAccount, DomainController)
    On Error Resume Next
    Set oConAD = CreateObject("ADODB.Connection")
    Set oCom = CreateObject("ADODB.Command")
    oConAD.Provider = "ADsDSOObject"
    oConAD.Open
    oCom.ActiveConnection = oConAD
    oCom.CommandText = "<LDAP://" & DomainController & "/" & gDomainRoot & ">;(&(objectClass=user)(samaccountname=" & UserAccount &"));samaccountname,distinguishedName,name;SubTree"
    Set aResult = oCom.Execute()
    sDistinguishedName = aResult("distinguishedName")
    sName = aResult("name")
    If Err.Number = 0 Then
        Set oUser = GetObject ("LDAP://" & DomainController & "/" & sDistinguishedName)
        If oUser.AccountDisabled = False Then
            If oUser.IsAccountLocked Then
                CheckUserStatus = UserAccount & " (" & sName & ") заблокирован"
            Else
                CheckUserStatus = UserAccount & " (" & sName & ") не заблокирован"
            End If
        Else
            CheckUserStatus = UserAccount & " (" & sName & ") отключен"
        End If
    Else
        CheckUserStatus = UserAccount & " не найден"
        Err.Number = 0
    End if
End Function

' Разблокировка учетной записи пользователя
Function UnlockUser(UserAccount, DomainController)
    On Error Resume Next
    Set oConAD = CreateObject("ADODB.Connection")
    Set oCom = CreateObject("ADODB.Command")
    oConAD.Provider = "ADsDSOObject"
    oConAD.Open
    oCom.ActiveConnection = oConAD
    oCom.CommandText = "<LDAP://" & DomainController & "/" & gDomainRoot & ">;(&(objectClass=user)(samaccountname=" & UserAccount &"));samaccountname,distinguishedName,name;SubTree"
    Set aResult = oCom.Execute()
    sDistinguishedName = aResult("distinguishedName")
    sName = aResult("name")
    If Err.Number = 0 Then
        Set oUser = GetObject ("LDAP://" & DomainController & "/" & sDistinguishedName)
        If oUser.AccountDisabled = False Then
            If oUser.IsAccountLocked then
                oUser.IsAccountLocked = False
                oUser.SetInfo
                If Err.Number = 0 then
                    UnlockUser = UserAccount & " (" & sName & ") разблокирован"
                Else
                    Err.Number = 0
                    UnlockUser = UserAccount & " (" & sName & ") не разблокирован - возможно, у вас не хватает прав"
                End if
            Else
                UnlockUser = UserAccount & " (" & sName & ") не заблокирован"
            End if
        Else
            UnlockUser = UserAccount & " (" & sName & ") отключен - вы не можете разблокировать отключенного пользователя"
        End If
    Else
        UnlockUser = UserAccount & " не найден"
        Err.Number = 0
    End If
End Function

' Получения срока действия пароля учетной записи
Function CheckWhenPasswordExpires(UserAccount, DomainController)
    On Error Resume Next
    Set oConAD = CreateObject("ADODB.Connection")
    Set oCom = CreateObject("ADODB.Command")
    oConAD.Provider = "ADsDSOObject"
    oConAD.Open
    oCom.ActiveConnection = oConAD
    oCom.CommandText = "<LDAP://" & DomainController & "/" & gDomainRoot & ">;(&(objectClass=user)(samaccountname=" & UserAccount &"));samaccountname,distinguishedName,name;SubTree"
    Set aResult = oCom.Execute()
    sDistinguishedName = aResult("distinguishedName")
    sName = aResult("name")
    If Err.Number = 0 Then
        Set oUser = GetObject ("LDAP://" & DomainController & "/" & sDistinguishedName)
        iCurrentValue = oUser.Get("userAccountControl")
        If iCurrentValue And ADS_UF_DONT_EXPIRE_PASSWD Then
            CheckWhenPasswordExpires = "Срок действия пароля пользователя " & UserAccount & " (" & sName & ") никогда не истечет"
        Else
            dtmValue = oUser.PasswordLastChanged 
            iTimeInterval = int(now - dtmValue)
            Set oDomainNT = GetObject("WinNT://glaverbel.com")
            iMaxPwdAge = oDomainNT.Get("MaxPasswordAge")
            If iMaxPwdAge < 0 Then
                CheckWhenPasswordExpires = "Срок действия пароля пользователя " & UserAccount & " (" & sName & ") никогда не истечет - политика домена"
            Else
                iMaxPwdAge = (iMaxPwdAge/SEC_IN_DAY)
                If iTimeInterval >= iMaxPwdAge Then
                    CheckWhenPasswordExpires = "Срок действия пароля пользователя " & UserAccount & " (" & sName & ") истек"
                Else
                    CheckWhenPasswordExpires = "Срок действия пароля пользователя " & UserAccount & " (" & sName & ") истекает " & DateValue(dtmValue + iMaxPwdAge) & " - через " & int((dtmValue + iMaxPwdAge) - Now) & " дней"
                End If
            End If
        End If
    Else
        CheckWhenPasswordExpires = UserAccount & " не найден"
        Err.Number = 0
    End If
End Function

' Сброс пароля учетной записи пользователя ()
Function ResetUserPassword(UserAccount, DomainController, NewPassword)
    On Error Resume Next
    iAnswer = MsgBox("Вы уверены, что нужно сбросить пароль пользователя " & UserAccount & "?", vbYesNo, "Подтверждение")
    If iAnswer = vbYes Then
        Set oConAD = CreateObject("ADODB.Connection")
        Set oCom = CreateObject("ADODB.Command")
        oConAD.Provider = "ADsDSOObject"
        oConAD.Open
        oCom.ActiveConnection = oConAD
        oCom.CommandText = "<LDAP://" & DomainController & "/" & gDomainRoot & ">;(&(objectClass=user)(samaccountname=" & UserAccount &"));samaccountname,distinguishedName,name;SubTree"
        Set aResult = oCom.Execute()
        sDistinguishedName = aResult("distinguishedName")
        sName = aResult("name")
        If Err.Number = 0 Then
            Set oUser = GetObject ("LDAP://" & DomainController & "/" & sDistinguishedName)
            If oUser.AccountDisabled = False Then
                If oUser.IsAccountLocked Then
                    oUser.SetPassword(LCase(NewPassword))
                    oUser.Put "pwdLastSet", 0
                    oUser.IsAccountLocked = False
                    oUser.SetInfo
                    If Err.Number = 0 Then
	                    ResetUserPassword = "Пароль пользователя " & UserAccount & " (" & sName & ") изменен, пользователь разблокирован"
                    Else
	                    Err.Number = 0
	                    ResetUserPassword = "Пароль пользователя " & UserAccount & " (" & sName & ") не изменен - возможно, у вас не хватает прав"
                    End If
                Else
                    oUser.SetPassword(LCase(UserAccount))
                    oUser.Put "pwdLastSet", 0
                    oUser.SetInfo
                    If Err.Number = 0 Then
	                    ResetUserPassword = "Пароль пользователя " & UserAccount & " (" & sName & ") изменен"
                    Else
	                    Err.Number = 0
	                    ResetUserPassword = "Пароль пользователя " & UserAccount & " (" & sName & ") не изменен - возможно, у вас не хватает прав"
                    End If
                End if
            Else
                ResetUserPassword = UserAccount & " (" & sName & ") отключен - вы не можете изменять пароль отключенного пользователя"
            End If
        Else
            ResetUserPassword = UserAccount & " не найден"
            Err.Number = 0
        End if
    Else
        ResetUserPassword = "Сброс пароля пользователя " & UserAccount & " отменен"
    End If
End Function

